//============================================================================
// Название    : Task3.cpp
// Автор       : Сергей Синица
// Компиляция  : g++ Task3.cpp
//============================================================================

#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

// проверяем сочетание и ищем максимум
void check_combination(std::vector<std::vector<int> > & gems_can_dig,
		std::vector<int> & combination,
		int max_dig_depth,
		int & max_gems) {

	// определяем для каждой уникальной пары x y максимальную глубину, на которую копаем
	std::vector<std::vector<int> > gems_digging;

	for (unsigned int i = 0; i < combination.size(); i++) {
		int gems_number = combination[i] - 1;
		std::vector<int> gems_dig =  gems_can_dig[gems_number];
		int gx = gems_dig[0];
		int gy = gems_dig[1];
		int gz = gems_dig[2];
		bool dig_found = false;
		for (unsigned j = 0; j < gems_digging.size(); j++) {
			std::vector<int> gems_diging_hole =  gems_digging[j];
			int gdx = gems_diging_hole[0];
			int gdy = gems_diging_hole[1];
			int gdz = gems_diging_hole[2];
			// если ранее копали в точке с этими координатами, то обновляем максимум глубины
			if (gx == gdx && gy == gdy) {
				dig_found = true;
				if (gz < gdz) {
					gems_digging[j][2] = gdz;
					break;
				}
			}
		}
		if (!dig_found) {
			gems_digging.push_back(gems_dig);
		}
	}

	// копаем в найденных точках и считаем количество добытых алмазов
	int dig_depth = 0;
	int gem_count = 0;
	for (unsigned int i = 0; i < gems_digging.size(); i++) {
		std::vector<int> gems_dig =  gems_digging[i];
		int gx = gems_dig[0];
		int gy = gems_dig[1];
		int gz = gems_dig[2];
		dig_depth += gz;

		// глубже копать нельзя
		if (dig_depth > max_dig_depth) {
			return;
		}

		// считаем в данной точке сколько добудем алмазов если будем копать на данную глубину
		for (unsigned j = 0; j < gems_can_dig.size(); j++) {
			std::vector<int> gems_can_dig_hole = gems_can_dig[j];
			int gdx = gems_can_dig_hole[0];
			int gdy = gems_can_dig_hole[1];
			int gdz = gems_can_dig_hole[2];
			if (gx == gdx && gy == gdy && gdz <= gz) {
				std::cout << "digged " << gdx << " " << gdy << " " << gdz << std::endl;
				gem_count++;
			}
		}
	}

	// обновляем максимум добытых алмазов
	if (gem_count > max_gems) {
		max_gems = gem_count;
	}
}

// генерируем сочетания позиций, в которых будем копать
void generate_combination(std::vector<std::vector<int> > & gems_can_dig, int combination_count,
		int num, int last, std::vector<int> & combination, int max_dig_depth, int & max_gems) {
	if (num == combination_count) {
		for (int i = 0; i < combination_count; i++)
			std::cout << combination[i];
		std::cout << std::endl;
		check_combination(gems_can_dig, combination, max_dig_depth, max_gems);
	}
	for (unsigned i = last + 1; i <= gems_can_dig.size(); i++) {
		combination.push_back(i);
		generate_combination(gems_can_dig, combination_count, num + 1, i, combination, max_dig_depth, max_gems);
		combination.pop_back();
	}
}

int main() {
	std::ifstream infile("task3.in");

	int n, x, y, a, b, z, t;
	infile >> n >> x >> y >> a >> b >> z >> t;

	int gems[n][3];

    for (int row = 0; row < n; row++) {
    	for (int col = 0; col < 3; col++) {
    		infile >> gems[row][col];
    	}
    }

    int gem_count = 0;
    int t_count = t * z;

    for (int row = 0; row < n; row++) {
    	int gx = gems[row][0];
    	int gy = gems[row][1];
    	int gz = gems[row][2];
    	if (gx > x && gx < x + a && gy > y && gy < y + b && gz <= t_count) {
    		gem_count++;
    	}
    }

    std::vector<std::vector<int> > gems_can_dig;
    for (int row = 0; row < n; row++) {
    	int gx = gems[row][0];
    	int gy = gems[row][1];
    	int gz = gems[row][2];
    	if (gx > x && gx < x + a && gy > y && gy < y + b && gz <= t_count) {
        	std::vector<int> g;
        	g.push_back(gx);
        	g.push_back(gy);
        	g.push_back(gz);
        	gems_can_dig.push_back(g);
    	}
    }

	int max_gems = 0;

	std::vector<int> combination;

	for (unsigned int i = 1; i <= gems_can_dig.size(); i++) {
	  combination.clear();
	  generate_combination(gems_can_dig, i, 0, 0, combination, t_count, max_gems);
	}

	std::ofstream outfile("task3.out");
	std::cout << max_gems;
    outfile << max_gems;

	return 0;
}
