//============================================================================
// Название    : Task5.cpp
// Автор       : Сергей Синица
// Компиляция  : g++ Task5.cpp
//============================================================================

#include <iostream>
#include <fstream>
#include <vector>
#include <list>
#include <string>
using namespace std;

int main() {
	std::ifstream infile("task5.in");

	std::string word;
	infile >> word;

	int n;
	infile >> n;

	std::vector<std::pair<std::string, char> > codes_vector(n);

	for (int i = 0; i < n; i++) {
		std::string codeword;
		infile >> codeword;
		char c;
		infile >> c;
		codes_vector[i] = std::make_pair(codeword, c);
	}

	std::list<std::pair<std::string, std::string> > open_list;

	std::list<std::string> decoded_words;

	open_list.push_back(std::make_pair("", word));


	while (open_list.size() > 0) {
		std::pair<std::string, std::string> search_variant = open_list.front();

		std::string decoded_word = search_variant.first;
		std::string remaining_word = search_variant.second;

		open_list.pop_front();

		for (int i = 0; i < n; i++) {
			std::pair<std::string, char> code = codes_vector[i];
			std::string codeword = code.first;
			char c = code.second;
			if (remaining_word.compare(0, codeword.length(), codeword) == 0) {
				std::string decoded_word_new = decoded_word + c;
				std::string remaining_word_new = remaining_word.substr(codeword.length(), string::npos);
				if (remaining_word_new.length() == 0) {
					decoded_words.push_back(decoded_word_new);
				}
				else {
				    open_list.push_back(std::make_pair(decoded_word_new, remaining_word_new));
				}
			}
		}
	}

	if (decoded_words.size() == 0) {
		return 0;
	}

	std::string min_word = decoded_words.front();
	decoded_words.pop_front();
	while (decoded_words.size() > 0) {
		std::string decoded_word = decoded_words.front();
		decoded_words.pop_front();
		if (decoded_word.length() < min_word.length()) {
			min_word = decoded_word;
		}
		else if (decoded_word.length() == min_word.length() &&
				decoded_word < min_word) {
			min_word = decoded_word;
		}
	}

	std::ofstream outfile("task5.out");
	outfile << min_word;

	return 0;
}
